/*
 *	Line buffer
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define _LINEBUF_C_
#include "linebuf.h"

#define DEFBUFSIZ 4096

extern char *errmsg;

/* label buffer */
unsigned long linebufsiz;
char *linebuf = 0;
unsigned long nextlineindex;

int init_linebuf(void) {
	errmsg = "out of memory";
	linebufsiz = DEFBUFSIZ;
	linebuf = malloc(linebufsiz);
	linebuf[0] = 0;
	nextlineindex = 1;	/* 0 should be kept unused */
	return 1;
}

void tini_linebuf(void) {
	if (linebuf) free(linebuf);
}

unsigned long add_linebuf(char *str) {	/* 0:error  otherwise:index */
	char *p;
	int l, r;
	l = strlen(str) + 1; /* length + EOS */
	if ((nextlineindex + l) >= linebufsiz) {
		linebufsiz += DEFBUFSIZ;
		p = realloc(linebuf, linebufsiz);
		if (p == NULL) {
			errmsg = "macro buffer overflow";
			return(0);
		}
		linebuf = p;
	}
	p = &linebuf[nextlineindex];
	strcpy(p, str);
/*printf("add_linebuf: %s\n",p);*/
	r = nextlineindex;
	nextlineindex += l;
	return r;
}

unsigned long add_linebuf_n(char *str, int len) {	/* 0:error  otherwise:index */
	char *p;
	int l, r;
	l = len + 1; /* length + EOS */
	if ((nextlineindex + l) >= linebufsiz) {
		linebufsiz += DEFBUFSIZ;
		p = realloc(linebuf, linebufsiz);
		if (p == NULL) {
			errmsg = "macro buffer overflow";
			return(0);
		}
		linebuf = p;
	}
	p = &linebuf[nextlineindex];
	strncpy(p, str, len);
	p[len] = 0;
/*printf("add_linebuf_n: %s\n",p);*/
	r = nextlineindex;
	nextlineindex += l;
	return r;
}

void end_addline(void) {
	add_linebuf("");
}

char *get_linebuf(unsigned long *lid) {
	char *p;
	if (*lid > nextlineindex) return 0;
	p = &linebuf[*lid];
	*lid += strlen(p)+1;
	if (!*p) return 0;
	return p;
}
